/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2021
 * AD9833
*/

//#define RESISTOR

//___________AD9833_______
#include <MD_AD9833.h>
#include <SPI.h>
#define DATA  11  ///< SPI Data pin number
#define CLK   13  ///< SPI Clock pin number
#define FSYNC 10  ///< SPI Load pin number (FSYNC in AD9833 usage)

MD_AD9833  AD(FSYNC);  // Hardware SPI


//___________OLED_________
#include "olex.h"
#include <Wire.h>

//__________ENCODER_______
#include <RotaryEncoder.h>
#define PIN_IN1 2
#define PIN_IN2 3
RotaryEncoder encoder(PIN_IN1, PIN_IN2, RotaryEncoder::LatchMode::TWO03);


long posicion;
long newPos;
long frecuencia;
unsigned char mode,modo=3;
static char *modoS[]={"OFF   ","SENO  ","TRIANGULO","CUADRADA"};
char nc=7;
int tiempo;
bool estado;
char digitos[12]={0,0,0,0,1,0,0,0,3};
long tmp;

char VARI[100];
char TITULO[]="--  AD9833v3  --";


void printLinea(void)
{
 int z;
  ModeFont=2;
  for(z=0;z<8;z++)  { xCaracterAT(z*2,2,48+digitos[z]);   }
  xCaracterAT(z*2,2,'H'); z++;  xCaracterAT(z*2,2,'z');
  ModeFont=1; sprintf(VARI,"%s",modoS[modo]);  xStringAT(0,4,VARI);
}

#define EBOTON 12

void setup() 
{
    Serial.begin(9600);
    Serial.println(TITULO);
    pinMode(EBOTON, INPUT);
    
#ifndef RESISTOR    
    pinMode(EBOTON,INPUT_PULLUP);
    pinMode(PIN_IN1,INPUT_PULLUP);
    pinMode(PIN_IN2,INPUT_PULLUP);
#endif

   AD.begin();
   AD.setFrequency(MD_AD9833::CHAN_0, 1000);
   mode = MD_AD9833::MODE_SQUARE1; 
   AD.setMode(mode);
  
    OleInit();
    xclearDisplay(); 
    ModeFont=0; xStringAT(0,0,TITULO);
    printLinea();
}


void loop() 
{
  delay(20);
  tiempo++;
  if(tiempo>20) 
  {
    
   if(estado==1)
    {
      estado=0;
      if(nc==8)
        { ModeFont=1; sprintf(VARI,"%s",modoS[modo]);  xStringAT(0,4,VARI);   }
       else
        { ModeFont=2; xCaracterAT(nc*2,2,48+digitos[nc]);  }    
    }
    else
    {
      estado=1;
      if(nc==8)
       { ModeFont=1; xStringAT(0,4,"         ");}
        else
       {ModeFont=2; xStringAT(nc*2,2," ");}
    }
   tiempo=0;
  }
    
  encoder.tick();
  newPos = encoder.getPosition();

  if (posicion != newPos) 
    {
      posicion = newPos;
      digitos[nc]=  newPos;

      if(nc==8)
      {
         if(digitos[nc]<0) { encoder.setPosition(3); digitos[nc]=3;}
         if(digitos[nc]>3) { encoder.setPosition(0); digitos[nc]=0;}
         modo=digitos[nc];

          switch (modo)
          {
            case 0 : mode = MD_AD9833::MODE_OFF;    break;
            case 1 : mode = MD_AD9833::MODE_SINE;   break;
            case 2 : mode = MD_AD9833::MODE_TRIANGLE;  break;
            case 3 : mode = MD_AD9833::MODE_SQUARE1;  break;
          }
          AD.setMode(mode);
      }
       else
      {
        if(digitos[nc]<0) 
          { 
            encoder.setPosition(9); digitos[nc]=9;
          }
        if(digitos[nc]>9) { encoder.setPosition(0); digitos[nc]=0;}
        printLinea();
        frecuencia=0;
        long multi=1;
        for(int z=7;z>=0;z--)
            {
              tmp=digitos[z];
              tmp*=multi;          
              frecuencia+=tmp;
               multi*=10;
            }
        } 
      sprintf(VARI,"Frecuencia=%li %s",frecuencia,modoS[modo]);
      Serial.println(VARI);
      AD.setFrequency(MD_AD9833::CHAN_0, frecuencia);
    } 
  
  if (LOW==digitalRead(12)) 
    {
      while(LOW==digitalRead(12)) delay(2);
      nc--;
      if (nc<0) nc=8;
      encoder.setPosition(digitos[nc]); 
      printLinea();   
    }
  
}
